// file      : xsd-frontend/semantic-graph/fundamental.hxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005-2010 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

// Note, that this file is automatically generated!
//

#ifndef XSD_FRONTEND_SEMANTIC_GRAPH_FUNDAMENTAL_HXX
#define XSD_FRONTEND_SEMANTIC_GRAPH_FUNDAMENTAL_HXX

#include <xsd-frontend/semantic-graph/elements.hxx>

namespace XSDFrontend
{
  namespace SemanticGraph
  {
    namespace Fundamental
    {
      //
      //
      class Type: public virtual SemanticGraph::Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        Type ();
      };


      //
      //
      class byte: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        byte (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class unsignedbyte: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        unsignedbyte (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class short: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        short (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class unsignedshort: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        unsignedshort (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class int: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        int (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class unsignedint: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        unsignedint (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class long: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        long (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class unsignedlong: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        unsignedlong (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class integer: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        integer (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class nonpositiveinteger: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        nonpositiveinteger (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class nonnegativeinteger: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        nonnegativeinteger (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class positiveinteger: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        positiveinteger (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class negativeinteger: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        negativeinteger (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class boolean: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        boolean (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class float: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        float (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class double: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        double (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class decimal: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        decimal (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class string: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        string (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class normalizedstring: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        normalizedstring (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class token: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        token (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class name: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        name (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class nametoken: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        nametoken (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class nametokens: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        nametokens (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class NCname: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        NCname (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class language: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        language (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class qname: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        qname (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class id: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        id (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class IdRef: public virtual Type,
                   public virtual Specialization
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        IdRef (Path const& file,
               SemanticGraph::UnsignedLong line,
               SemanticGraph::UnsignedLong column);
      };


      //
      //
      class IdRefs: public virtual Type,
                    public virtual Specialization
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        IdRefs (Path const& file,
                SemanticGraph::UnsignedLong line,
                SemanticGraph::UnsignedLong column);
      };


      //
      //
      class anyURI: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        anyURI (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class base64binary: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        base64binary (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class hexbinary: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        hexbinary (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class date: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        date (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class datetime: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        datetime (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class duration: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        duration (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class day: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        day (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class month: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        month (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class monthday: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        monthday (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class year: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        year (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class yearmonth: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        yearmonth (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class time: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        time (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class entity: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        entity (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class entities: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        entities (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };


      //
      //
      class notation: public virtual Type
      {
      protected:
        friend class Bits::Graph<Node, Edge>;

        notation (Path const& file,
            SemanticGraph::UnsignedLong line,
            SemanticGraph::UnsignedLong column);
      };
    }
  }
}

#endif  // XSD_FRONTEND_SEMANTIC_GRAPH_FUNDAMENTAL_HXX
